



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>35、concurrent.futures模块与协程</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">35、concurrent.futures模块与协程</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-28 20:08:55 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>concurrent.futures&nbsp;&nbsp;&mdash;Launching parallel tasks &nbsp; &nbsp;concurrent.futures模块同时提供了进程池和线程池，它是将来的使用趋势，同样我们之前学习的进程池Pool和threadpool模块也可以使用。</p>
<p>对进程池疑惑的可以参阅：32进程池与回调函数<a href="http://www.cnblogs.com/liluning/p/7445457.html" rel="external nofollow noreferrer">http://www.cnblogs.com/liluning/p/7445457.html</a></p>
<p>对threadpool模块疑惑的可以看我闲暇时写的一段代码：（因为本人也不了解这个模块，代码里写的也是自己想当然的，如有问题请自行查阅资料）</p>
<div>
<div>
<pre class="prettyprint linenums">#pip3 install threadpool  #需下载<br />
import threadpool<br />
import requests<br />
import re<br />
import os

#爬取网页<br />
def get_page(url) :<br />
    pattern = re.compile(r'&lt;dd&gt;.*?board-index.*?&gt;(\d+)&lt;.*?title="(.*?)".*?star.*?&gt;(.*?)&lt;.*?releasetime.*?&gt;(.*?)&lt;', re.S)<br />
    response = requests.get(url)<br />
    if response.status_code == 200 :<br />
    #status_code请求的状态码200为正常<br />
        return (response.text,pattern,url)

#信息处理<br />
def parse_page(info) :<br />
    page_content,pattern,url = info<br />
    print('&lt;%s&gt; parse [%s]'% (os.getpid(), url))<br />
    res = re.findall(pattern,page_content)<br />
    dic_l = []<br />
    for item in res:<br />
        dic = {<br />
            'index':item[0],<br />
            'title':item[1],<br />
            'actor':item[2].strip()[3:],<br />
            'time':item[3][5:]<br />
        }<br />
        dic_l.append(dic)<br />
        print(dic)<br />
    with open('movie_info.txt','a',encoding='utf-8') as f :<br />
        for i in range(len(dic_l)) :<br />
            parse_res = ('index:%s title:%s actor:%s time:%s\n' %(dic_l[i]['index'],dic_l[i]['title'],dic_l[i]['actor'],dic_l[i]['time']))<br />
            f.write(parse_res)

if __name__ == '__main__':<br />
    urls = [<br />
        'http://maoyan.com/board/7',<br />
        'http://maoyan.com/board/6',<br />
        'http://maoyan.com/board/1',<br />
        'http://maoyan.com/board/2',<br />
        'http://maoyan.com/board/4',<br />
    ]<br />
    t = threadpool.ThreadPool(4)  #创建线程池<br />
    for url in urls :<br />
        res = threadpool.makeRequests(get_page,urls,parse_page(get_page(url)))<br />
    #参数：执行函数，参数，回调函数<br />
    [t.putRequest(req) for req in res]<br />
    t.wait()</pre>
</div>
<p>基于threadpool猫眼爬虫</p></div>
<p><strong>一、concurrent.futures模块</strong></p>
<p><strong>1、官方文档</strong></p>
<p><a href="https://docs.python.org/dev/library/concurrent.futures.html#module-concurrent.futures" rel="external nofollow noreferrer">https://docs.python.org/dev/library/concurrent.futures.html#module-concurrent.futures</a></p>
<p><strong>2、</strong><strong>ProcessPoolExecutor（进程池）与ThreadPoolExecutor（线程池）</strong></p>
<p>（进程池类与线程池类的方法使用等各方面基本相同）</p>
<p>1）导入</p>
<div>
<pre class="prettyprint linenums">from concurrent.futures import ProcessPoolExecutor,ThreadPoolExecutor</pre>
</div>
<p>2）创建</p>
<div>
<pre class="prettyprint linenums">p = ProcessPoolExecutor(num)  #创建进程池<br />
t = ThreadPoolExecutor(num)  #创建线程池</pre>
</div>
<p>3）参数</p>
<div>
<pre class="prettyprint linenums">num:要创建的进程数或线程数，如果省略，进程数将默认使用cpu_count()的值，线程数将默认使用cpu_count()*5的值</pre>
</div>
<p>4）主要方法</p>
<div>
<pre class="prettyprint linenums">submit(fn, *args, **kwargs)：在一个池工作进程中执行执行fn(args kwargs)执行，并返回一个表示可调用的执行的Future对象<br />
map(func, *iterables, timeout=None, chunksize=1)：<br />
shutdown(wait=True)：执行结束释放资源</pre>
</div>
<p><strong>3、应用</strong></p>
<p>1）进程池</p>
<div>
<pre class="prettyprint linenums">from concurrent.futures import ProcessPoolExecutor<br />
import os,time<br />
def task(n):<br />
    print('%s is running' %os.getpid())<br />
    time.sleep(2)<br />
    return n**2

if __name__ == '__main__':<br />
    p=ProcessPoolExecutor()<br />
    l=[]<br />
    start=time.time()<br />
    for i in range(10):<br />
        obj=p.submit(task,i)<br />
        l.append(obj)<br />
    p.shutdown()<br />
    print('='*30)<br />
    print([obj for obj in l])<br />
    print([obj.result() for obj in l])<br />
    print(time.time()-start)</pre>
</div>
<p>2）线程池</p>
<div>
<pre class="prettyprint linenums">from concurrent.futures import ThreadPoolExecutor<br />
import threading<br />
import os,time<br />
def task(n):<br />
    print('%s:%s is running' %(threading.currentThread().getName(),os.getpid()))<br />
    time.sleep(2)<br />
    return n**2

if __name__ == '__main__':<br />
    p=ThreadPoolExecutor()<br />
    l=[]<br />
    start=time.time()<br />
    for i in range(10):<br />
        obj=p.submit(task,i)<br />
        l.append(obj)<br />
    p.shutdown()<br />
    print('='*30)<br />
    print([obj.result() for obj in l])<br />
    print(time.time()-start)</pre>
</div>
<p>3）同步执行</p>
<div>
<pre class="prettyprint linenums">from concurrent.futures import ProcessPoolExecutor,ThreadPoolExecutor<br />
import os,time,random<br />
def task(n):<br />
    print('%s is running' %os.getpid())<br />
    time.sleep(2)<br />
    return n**2

if __name__ == '__main__':<br />
    p=ProcessPoolExecutor()<br />
    start=time.time()<br />
    for i in range(10):<br />
        res=p.submit(task,i).result()<br />
        print(res)<br />
    print('='*30)<br />
    print(time.time()-start)</pre>
</div>
<p><strong>4、回调函数&nbsp;</strong></p>
<p>不懂回调函数的看本章节首部有链接</p>
<div>
<pre class="prettyprint linenums">from concurrent.futures import ThreadPoolExecutor<br />
import requests, os, time<br />
from threading import currentThread<br />
def get_page(url):<br />
    print('%s:&lt;%s&gt; is getting [%s]' %(currentThread().getName(),os.getpid(),url))<br />
    response=requests.get(url)<br />
    time.sleep(2)<br />
    return {'url':url,'text':response.text}<br />
def parse_page(res):<br />
    res=res.result()  #注意值<br />
    print('%s:&lt;%s&gt; parse [%s]' %(currentThread().getName(),os.getpid(),res['url']))<br />
    with open('db.txt','a') as f:<br />
        parse_res='url:%s size:%s\n' %(res['url'],len(res['text']))<br />
        f.write(parse_res)<br />
if __name__ == '__main__':<br />
    p=ThreadPoolExecutor()<br />
    urls = [<br />
        'https://www.baidu.com',<br />
        'http://www.openstack.org',<br />
        'https://www.python.org',<br />
        'http://www.sina.com.cn/'<br />
    ]

    for url in urls:<br />
        p.submit(get_page, url).add_done_callback(parse_page)<br />
        #add_done_callback()回调函数<br />
    p.shutdown()<br />
    print('主',os.getpid())</pre>
</div>
<p><strong>5、map方法</strong></p>
<p>map有疑惑可以阅览：19、内置函数和匿名函数<a href="http://www.cnblogs.com/liluning/p/7280832.html" rel="external nofollow noreferrer">http://www.cnblogs.com/liluning/p/7280832.html</a></p>
<div>
<pre class="prettyprint linenums">from concurrent.futures import ProcessPoolExecutor<br />
import os,time<br />
def task(n):<br />
    print('%s is running' %os.getpid())<br />
    time.sleep(2)<br />
    return n**2

if __name__ == '__main__':<br />
    p=ProcessPoolExecutor()<br />
    obj=p.map(task,range(10))<br />
    p.shutdown()<br />
    print('='*30)<br />
    print(list(obj))</pre>
</div>
<hr />
<p><strong>二、协程概念</strong></p>
<p><strong>1、定义</strong></p>
<p>是单线程下的并发，又称微线程，纤程。英文名Coroutine。一句话说明什么是线程：协程是一种用户态的轻量级线程，即协程是由用户程序自己控制调度的。</p>
<p><strong>2、注意</strong></p>
<p>1）python的线程属于内核级别的，即由操作系统控制调度（如单线程遇到io或执行时间过长就会被迫交出cpu执行权限，切换其他线程运行）</p>
<p>2）单线程内开启协程，一旦遇到io，就会从应用程序级别（而非操作系统）控制切换，以此来提升效率（！！！非io操作的切换与效率无关）</p>
<p><strong>3、优点</strong></p>
<p>1） 协程的切换开销更小，属于程序级别的切换，操作系统完全感知不到，因而更加轻量级</p>
<p>2） 单线程内就可以实现并发的效果，最大限度地利用cpu</p>
<p><strong>4、缺点</strong></p>
<p>1） 协程的本质是单线程下，无法利用多核，可以是一个程序开启多个进程，每个进程内开启多个线程，每个线程内开启协程</p>
<p>2） 协程指的是单个线程，因而一旦协程出现阻塞，将会阻塞整个线程</p>
<p><strong>5、总结</strong></p>
<p>1）必须在只有一个单线程里实现并发</p>
<p>2）修改共享数据不需加锁</p>
<p>3）用户程序里自己保存多个控制流的上下文栈</p>
<p>附加：一个协程遇到IO操作自动切换到其它协程（如何实现检测IO，yield、greenlet都无法实现，就用到了gevent模块（select机制））</p>
<hr />
<p><strong>三、greenlet模块</strong></p>
<p>如果我们在单个线程内有20个任务，要想实现在多个任务之间切换，使用yield生成器的方式过于麻烦（需要先得到初始化一次的生成器，然后再调用send。。。非常麻烦），而使用greenlet模块可以非常简单地实现这20个任务直接的切换</p>
<p>生成器：18、迭代器和生成器<a href="http://www.cnblogs.com/liluning/p/7274862.html" rel="external nofollow noreferrer">http://www.cnblogs.com/liluning/p/7274862.html</a></p>
<p><strong>1、安装</strong></p>
<div>
<pre class="prettyprint linenums">pip3 install greenlet</pre>
</div>
<p><strong>2、使用</strong></p>
<div>
<pre class="prettyprint linenums">from greenlet import greenlet

def eat(name):<br />
    print('%s eat 1' %name)<br />
    g2.switch('egon')<br />
    print('%s eat 2' %name)<br />
    g2.switch()<br />
def play(name):<br />
    print('%s play 1' %name)<br />
    g1.switch()<br />
    print('%s play 2' %name)

g1=greenlet(eat)<br />
g2=greenlet(play)

g1.switch('egon')#可以在第一次switch时传入参数，以后都不需要</pre>
</div>
<p><strong>3、单纯的切换（在没有io的情况下或者没有重复开辟内存空间的操作），反而会降低程序的执行速度</strong></p>
<div>
<div>
<pre class="prettyprint linenums">#顺序执行<br />
import time<br />
def f1():<br />
    res=1<br />
    for i in range(100000000):<br />
        res+=i

def f2():<br />
    res=1<br />
    for i in range(100000000):<br />
        res*=i

start=time.time()<br />
f1()<br />
f2()<br />
stop=time.time()<br />
print('run time is %s' %(stop-start)) #10.985628366470337

#切换<br />
from greenlet import greenlet<br />
import time<br />
def f1():<br />
    res=1<br />
    for i in range(100000000):<br />
        res+=i<br />
        g2.switch()

def f2():<br />
    res=1<br />
    for i in range(100000000):<br />
        res*=i<br />
        g1.switch()

start=time.time()<br />
g1=greenlet(f1)<br />
g2=greenlet(f2)<br />
g1.switch()<br />
stop=time.time()<br />
print('run time is %s' %(stop-start)) # 52.763017892837524</pre>
</div>
</div>
<p>单线程里的这20个任务的代码通常会既有计算操作又有阻塞操作，我们完全可以在执行任务1时遇到阻塞，就利用阻塞的时间去执行任务2。。。。如此，才能提高效率，这就用到了Gevent模块。</p>
<hr />
<p><strong>四、Gevent模块</strong></p>
<p><strong>1、安装</strong></p>
<div>
<pre class="prettyprint linenums">pip3 install gevent</pre>
</div>
<p>Gevent 是一个第三方库，可以轻松通过gevent实现并发同步或异步编程，在gevent中用到的主要模式是<strong>Greenlet</strong>, 它是以C扩展模块形式接入Python的轻量级协程。 Greenlet全部运行在主程序操作系统进程的内部，但它们被协作式地调度。</p>
<p><strong>2、用法</strong></p>
<div>
<pre class="prettyprint linenums">g1=gevent.spawn(func,1,,2,3,x=4,y=5)创建一个协程对象g1，spawn括号内第一个参数是函数名，如eat，后面可以有多个参数，可以是位置实参或关键字实参，都是传给函数eat的

g2=gevent.spawn(func2)

g1.join() #等待g1结束

g2.join() #等待g2结束

#或者上述两步合作一步：gevent.joinall([g1,g2])

g1.value#拿到func1的返回值</pre>
</div>
<p><strong>3、遇到IO阻塞时会自动切换任务</strong></p>
<div>
<div>
<pre class="prettyprint linenums">import gevent<br />
def eat(name):<br />
    print('%s eat 1' %name)<br />
    gevent.sleep(2)<br />
    print('%s eat 2' %name)

def play(name):<br />
    print('%s play 1' %name)<br />
    gevent.sleep(1)<br />
    print('%s play 2' %name)

g1=gevent.spawn(eat,'egon')<br />
g2=gevent.spawn(play,name='egon')<br />
g1.join()<br />
g2.join()<br />
#或者gevent.joinall([g1,g2])<br />
print('主')</pre>
</div>
</div>
<p>上例gevent.sleep(2)模拟的是gevent可以识别的io阻塞,而time.sleep(2)或其他的阻塞,gevent是不能直接识别的需要用下面一行代码,打补丁,就可以识别了from gevent import monkey;monkey.patch_all()必须放到被打补丁者的前面，如time，socket模块之前或者我们干脆记忆成：要用gevent，需要将from gevent import monkey;monkey.patch_all()放到文件的开头</p>
<div>
<div>
<pre class="prettyprint linenums">from gevent import monkey;monkey.patch_all()

import gevent<br />
import time<br />
def eat():<br />
    print('eat food 1')<br />
    time.sleep(2)<br />
    print('eat food 2')

def play():<br />
    print('play 1')<br />
    time.sleep(1)<br />
    print('play 2')

g1=gevent.spawn(eat)<br />
g2=gevent.spawn(play_phone)<br />
gevent.joinall([g1,g2])<br />
print('主')</pre>
</div>
</div>
<p><strong>4、Gevent的同步与异步</strong></p>
<div>
<div>
<pre class="prettyprint linenums">from gevent import spawn,joinall,monkey;monkey.patch_all()

import time<br />
def task(pid):<br />
    """<br />
    Some non-deterministic task<br />
    """<br />
    time.sleep(0.5)<br />
    print('Task %s done' % pid)

def synchronous():<br />
    for i in range(10):<br />
        task(i)

def asynchronous():<br />
    g_l=[spawn(task,i) for i in range(10)]<br />
    joinall(g_l)

if __name__ == '__main__':<br />
    print('Synchronous:')<br />
    synchronous()

    print('Asynchronous:')<br />
    asynchronous()<br />
#上面程序的重要部分是将task函数封装到Greenlet内部线程的gevent.spawn。 初始化的greenlet列表存放在数组threads中，此数组被传给gevent.joinall 函数，后者阻塞当前流程，并执行所有给定的greenlet。执行流程只会在 所有greenlet执行完后才会继续向下走。</pre>
</div>
</div>
<p><strong>5、Gevent实现爬虫</strong></p>
<div>
<pre class="prettyprint linenums">from gevent import monkey;monkey.patch_all()<br />
import gevent<br />
import requests<br />
import time

def get_page(url):<br />
    print('GET: %s' %url)<br />
    response=requests.get(url)<br />
    if response.status_code == 200:<br />
        print('%d bytes received from %s' %(len(response.text),url))

start_time=time.time()<br />
g1=gevent.spawn(get_page, 'https://www.python.org/')<br />
g2=gevent.spawn(get_page, 'https://www.yahoo.com/')<br />
g3=gevent.spawn(get_page, 'https://github.com/')<br />
gevent.joinall([g1,g2,g3])<br />
stop_time=time.time()<br />
print('run time is %s' %(stop_time-start_time))</pre>
</div>
<p><strong>6、gevent实现单线程下的socket并发</strong></p>
<p>通过gevent实现单线程下的socket并发（from gevent import monkey;monkey.patch_all()一定要放到导入socket模块之前，否则gevent无法识别socket的阻塞）</p>
<div>
<div>
<pre class="prettyprint linenums">from gevent import monkey;monkey.patch_all()<br />
from socket import *<br />
import gevent

#如果不想用money.patch_all()打补丁,可以用gevent自带的socket<br />
# from gevent import socket<br />
# s=socket.socket()

def server(server_ip,port):<br />
    s=socket(AF_INET,SOCK_STREAM)<br />
    s.setsockopt(SOL_SOCKET,SO_REUSEADDR,1)<br />
    s.bind((server_ip,port))<br />
    s.listen(5)<br />
    while True:<br />
        conn,addr=s.accept()<br />
        gevent.spawn(talk,conn,addr)

def talk(conn,addr):<br />
    try:<br />
        while True:<br />
            res=conn.recv(1024)<br />
            print('client %s:%s msg: %s' %(addr[0],addr[1],res))<br />
            conn.send(res.upper())<br />
    except Exception as e:<br />
        print(e)<br />
    finally:<br />
        conn.close()

if __name__ == '__main__':<br />
    server('127.0.0.1',8080)</pre>
</div>
<p>服务端</p></div>
<div>
<div>
<pre class="prettyprint linenums">from socket import *

client=socket(AF_INET,SOCK_STREAM)<br />
client.connect(('127.0.0.1',8080))

while True:<br />
    msg=input('&gt;&gt;: ').strip()<br />
    if not msg:continue

    client.send(msg.encode('utf-8'))<br />
    msg=client.recv(1024)<br />
    print(msg.decode('utf-8'))</pre>
</div>
<p>客户端</p></div>
<p><strong>7、多协程发送多个客户端</strong></p>
<div>
<div>
<pre class="prettyprint linenums">from gevent import monkey;monkey.patch_all()<br />
import gevent<br />
from socket import *<br />
def talk(conn,addr):<br />
    while True:<br />
        data=conn.recv(1024)<br />
        print('%s:%s %s' %(addr[0],addr[1],data))<br />
        conn.send(data.upper())<br />
    conn.close()

def server(ip,port):<br />
    s = socket(AF_INET, SOCK_STREAM)<br />
    s.setsockopt(SOL_SOCKET, SO_REUSEADDR, 1)<br />
    s.bind((ip,port))<br />
    s.listen(5)<br />
    while True:<br />
        conn,addr=s.accept()<br />
        gevent.spawn(talk,conn,addr)<br />
    s.close()

if __name__ == '__main__':<br />
    server('127.0.0.1', 8088)</pre>
</div>
<p>服务端</p></div>
<div>
<div>
<pre class="prettyprint linenums">from multiprocessing import Process<br />
from socket import *<br />
def client(server_ip,server_port):<br />
    client=socket(AF_INET,SOCK_STREAM)<br />
    client.connect((server_ip,server_port))<br />
    while True:<br />
        client.send('hello'.encode('utf-8'))<br />
        msg=client.recv(1024)<br />
        print(msg.decode('utf-8'))

if __name__ == '__main__':<br />
    for i in range(500):<br />
        p=Process(target=client,args=('127.0.0.1',8088))<br />
        p.start()</pre>
</div>
<p>客户端</p></div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/4qnvpgk8.html">ASP&period;NET MVC4 Forms 登录验证</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8myd768.html">javaweb中实现在线人数统计</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8erj4kq.html">经验分享：CSS浮动&lpar;float&comma;clear&rpar;通俗讲解</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvnr2z9.html">【USACO 1&period;4】Mother&amp;&num;39&semi;s Milk</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqdy04jq.html">eclipse将编辑栏一分为二</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvl47j8.html">破解android手机图形锁</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9p1lgd9.html">第二篇 Integration Services：SSIS数据泵</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e12pye9.html">正则表达式 和 junit测试</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2j3ryo8.html">TCP三次握手和四次挥手</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdp1zm7q.html">201621123057 《Java程序设计》第13周学习总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpzn639.html">Java类加载器的工作原理</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1mwwoq.html">Key-Value Store Indexer&lpar;Lily HBase Indexer&rpar; 小型采坑</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7om7dg8.html">如何使用idea给系统平台添加子应用和应用的模块</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxd5y3d9.html">JS&lowbar;高程4&period;变量，作用域和内存问题（1）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyy5z5mq.html">&lbrack;转&rsqb;客户端js判断文件类型和文件大小即限制上传大小</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1r2ooz8.html">&lbrack;CNBETA&rsqb;Intel CPU底层漏洞事件完全详解：全球手机&sol;电脑无一幸免&lbrack;转帖&rsqb;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25oe6vq.html">tcp&sol;ip通信第5期之服务器端程序</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1vrpl6q.html">Android控件进阶-自定义流式布局和热门标签控件</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kojvn3q.html">iOS获取ipa素材、提取ipa资源图片文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mj7o2r8.html">An Introduction to Text Mining using Twitter Streaming</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/q4jnv60q.html">Java基础知识➣面向对象（八）</a>
			</li>
						<li><a href="https://www.batexi.com/a/93wn4rnq.html">分享几个在线生成网址二维码的API接口</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kj5ewr9.html">python全栈开发day73-Django认证系统</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7on65g8.html">P1101 单词方阵   简单dfs</a>
			</li>
						<li><a href="https://www.batexi.com/a/8o157vxq.html">PAT &lpar;Basic Level&rpar; Practise - 继续&lpar;3n&plus;1&rpar;猜想</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zyjm7v9.html">spring security学习</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4jnemnq.html">Spring事务的传播：PROPAGATION&lowbar;REQUIRED</a>
			</li>
						<li><a href="https://www.batexi.com/a/95gj5z0q.html">Codeforces 208A-Dubstep&lpar;字符串&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1rjgd48.html">hive参数配置及任务优化</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kjv1z79.html">php手撸轻量级开发（三）composer小白入门</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
